﻿using Infragistics.Controls.Maps;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace GeoMapLineColors
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public List<RouteColor> Route { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            // create the route
            Route = new List<RouteColor>();
            Route.Add(new RouteColor { Color = Colors.Green });
            Route.Add(new RouteColor { Color = Colors.Yellow });
            Route.Add(new RouteColor { Color = Colors.Red });

            var greenPoints = new List<IEnumerable<Point>>();
            greenPoints.Add(new List<Point> { new Point(-75.058594, 39.198205), new Point(-81.035156, 28.420391), new Point(-57.128906, 6.096860) });
            greenPoints.Add(new List<Point> { new Point(32.167969, -11.738302), new Point(45.175781, -20.179724) });

            var yellowPoints = new List<IEnumerable<Point>>();
            yellowPoints.Add(new List<Point> { new Point(-57.128906, 6.096860), new Point(-34.980469, -6.184246) });

            var redPoints = new List<IEnumerable<Point>>();
            redPoints.Add(new List<Point> { new Point(-34.980469, -6.184246), new Point(20.214844, -32.138409), new Point(32.167969, -11.738302) });

            Route[0].Points = greenPoints;
            Route[1].Points = yellowPoints;
            Route[2].Points = redPoints;

            // set the data context
            this.DataContext = this;
        }
    }

    public class RouteColor
    {
        public Color Color { get; set; }

        public IEnumerable<IEnumerable<Point>> Points { get; set; }
    }

    public class RouteStyleSelector : StyleSelector
    {
        public override Style SelectStyle(object item, DependencyObject container)
        {
            var routeColor = item as RouteColor;
            var pathStyle = new Style(typeof(Path));
            pathStyle.Setters.Add(new Setter(Path.StrokeProperty, new SolidColorBrush(routeColor.Color)));

            return pathStyle;
        }
    }
}
